Index: sasmodels/models/barbell.c
===================================================================
--- sasmodels/models/barbell.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/barbell.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -33,5 +33,5 @@
         const double t = Gauss76Z[i]*zm + zb;
         const double radical = 1.0 - t*t;
-        const double bj = sas_J1c(qrst*sqrt(radical));
+        const double bj = sas_2J1x_x(qrst*sqrt(radical));
         const double Fq = cos(m*t + b) * radical * bj;
         total += Gauss76Wt[i] * Fq;
@@ -39,7 +39,21 @@
     // translate dx in [-1,1] to dx in [lower,upper]
     const double integral = total*zm;
-    const double bell_Fq = 2*M_PI*cube(radius_bell)*integral;
-    return bell_Fq;
+    const double bell_fq = 2.0*M_PI*cube(radius_bell)*integral;
+    return bell_fq;
 }
+
+static double
+_fq(double q, double h,
+    double radius_bell, double radius, double half_length,
+    double sin_alpha, double cos_alpha)
+{
+    const double bell_fq = _bell_kernel(q, h, radius_bell, half_length, sin_alpha, cos_alpha);
+    const double bj = sas_2J1x_x(q*radius*sin_alpha);
+    const double si = sas_sinx_x(q*half_length*cos_alpha);
+    const double cyl_fq = 2.0*M_PI*radius*radius*half_length*bj*si;
+    const double Aq = bell_fq + cyl_fq;
+    return Aq;
+}
+
 
 double form_volume(double radius_bell,
@@ -47,5 +61,4 @@
         double length)
 {
-
     // bell radius should never be less than radius when this is called
     const double hdist = sqrt(square(radius_bell) - square(radius));
@@ -71,10 +84,5 @@
         double sin_alpha, cos_alpha; // slots to hold sincos function output
         SINCOS(alpha, sin_alpha, cos_alpha);
-
-        const double bell_Fq = _bell_kernel(q, h, radius_bell, half_length, sin_alpha, cos_alpha);
-        const double bj = sas_J1c(q*radius*sin_alpha);
-        const double si = sinc(q*half_length*cos_alpha);
-        const double cyl_Fq = M_PI*radius*radius*length*bj*si;
-        const double Aq = bell_Fq + cyl_Fq;
+        const double Aq = _fq(q, h, radius_bell, radius, half_length, sin_alpha, cos_alpha);
         total += Gauss76Wt[i] * Aq * Aq * sin_alpha;
     }
@@ -93,21 +101,9 @@
         double theta, double phi)
 {
-    // Compute angle alpha between q and the cylinder axis
-    double sn, cn; // slots to hold sincos function output
-    SINCOS(phi*M_PI_180, sn, cn);
-    const double q = sqrt(qx*qx + qy*qy);
-    const double cos_val = (q==0. ? 1.0 : (cn*qx + sn*qy)*sin(theta*M_PI_180)/q);
-    const double alpha = acos(cos_val); // rod angle relative to q
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
 
     const double h = -sqrt(square(radius_bell) - square(radius));
-    const double half_length = 0.5*length;
-
-    double sin_alpha, cos_alpha; // slots to hold sincos function output
-    SINCOS(alpha, sin_alpha, cos_alpha);
-    const double bell_Fq = _bell_kernel(q, h, radius_bell, half_length, sin_alpha, cos_alpha);
-    const double bj = sas_J1c(q*radius*sin_alpha);
-    const double si = sinc(q*half_length*cos_alpha);
-    const double cyl_Fq = M_PI*radius*radius*length*bj*si;
-    const double Aq = cyl_Fq + bell_Fq;
+    const double Aq = _fq(q, h, radius_bell, radius, 0.5*length, sin_alpha, cos_alpha);
 
     // Multiply by contrast^2 and convert to cm-1
Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/barbell.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
@@ -20,23 +20,23 @@
 .. math::
 
-    I(q) = \frac{\Delta \rho^2}{V} \left<A^2(q)\right>
+    I(q) = \frac{\Delta \rho^2}{V} \left<A^2(q,\alpha).sin(\alpha)\right>
 
-where the amplitude $A(q)$ is given as
+where the amplitude $A(q,\alpha)$ with the rod axis at angle $\alpha$ to $q$ is given as
 
 .. math::
 
     A(q) =&\ \pi r^2L
-        \frac{\sin\left(\tfrac12 qL\cos\theta\right)}
-             {\tfrac12 qL\cos\theta}
-        \frac{2 J_1(qr\sin\theta)}{qr\sin\theta} \\
+        \frac{\sin\left(\tfrac12 qL\cos\alpha\right)}
+             {\tfrac12 qL\cos\alpha}
+        \frac{2 J_1(qr\sin\alpha)}{qr\sin\alpha} \\
         &\ + 4 \pi R^3 \int_{-h/R}^1 dt
-        \cos\left[ q\cos\theta
+        \cos\left[ q\cos\alpha
             \left(Rt + h + {\tfrac12} L\right)\right]
         \times (1-t^2)
-        \frac{J_1\left[qR\sin\theta \left(1-t^2\right)^{1/2}\right]}
-             {qR\sin\theta \left(1-t^2\right)^{1/2}}
+        \frac{J_1\left[qR\sin\alpha \left(1-t^2\right)^{1/2}\right]}
+             {qR\sin\alpha \left(1-t^2\right)^{1/2}}
 
 The $\left<\ldots\right>$ brackets denote an average of the structure over
-all orientations. $\left<A^2(q)\right>$ is then the form factor, $P(q)$.
+all orientations. $\left<A^2(q,\alpha)\right>$ is then the form factor, $P(q)$.
 The scale factor is equivalent to the volume fraction of cylinders, each of
 volume, $V$. Contrast $\Delta\rho$ is the difference of scattering length
@@ -85,5 +85,5 @@
 * **Author:** NIST IGOR/DANSE **Date:** pre 2010
 * **Last Modified by:** Paul Butler **Date:** March 20, 2016
-* **Last Reviewed by:** Paul Butler **Date:** March 20, 2016
+* **Last Reviewed by:** Richard Heenan **Date:** January 4, 2017
 """
 from numpy import inf
Index: sasmodels/models/bcc_paracrystal.c
===================================================================
--- sasmodels/models/bcc_paracrystal.c	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/bcc_paracrystal.c	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -31,6 +31,7 @@
 	const double temp8 = -sin_theta*cos_phi - sin_theta*sin_phi + cos_theta;
 	const double temp9 = -sin_theta*cos_phi + sin_theta*sin_phi - cos_theta;
+
 	const double temp10 = exp((-1.0/8.0)*temp1*(temp7*temp7 + temp8*temp8 + temp9*temp9));
-	result = pow(1.0-(temp10*temp10),3)*temp6
+	result = cube(1.0 - (temp10*temp10))*temp6
 	    / ( (1.0 - 2.0*temp10*cos(0.5*temp3*temp7) + temp10*temp10)
 	      * (1.0 - 2.0*temp10*cos(0.5*temp3*temp8) + temp10*temp10)
@@ -81,90 +82,30 @@
 
     return answer;
-
-
 }
 
 
-double Iqxy(double qx, double qy, double dnn,
-    double d_factor, double radius,double sld, double solvent_sld,
-    double theta, double phi, double psi){
+double Iqxy(double qx, double qy,
+    double dnn, double d_factor, double radius,
+    double sld, double solvent_sld,
+    double theta, double phi, double psi)
+{
+    double q, cos_a1, cos_a2, cos_a3;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_a3, cos_a2, cos_a1);
 
-  double b3_x, b3_y, b1_x, b1_y, b2_x, b2_y; //b3_z,
-  //double q_z;
-  double cos_val_b3, cos_val_b2, cos_val_b1;
-  double a1_dot_q, a2_dot_q,a3_dot_q;
-  double answer;
-  double Zq, Fkq, Fkq_2;
+    const double a1 = +cos_a3 - cos_a1 + cos_a2;
+    const double a2 = +cos_a3 + cos_a1 - cos_a2;
+    const double a3 = -cos_a3 + cos_a1 + cos_a2;
 
-  //convert to q and make scaled values
-  double q = sqrt(qx*qx+qy*qy);
-  double q_x = qx/q;
-  double q_y = qy/q;
+    const double qd = 0.5*q*dnn;
+    const double arg = 0.5*square(qd*d_factor)*(a1*a1 + a2*a2 + a3*a3);
+    const double tanh_qd = tanh(arg);
+    const double cosh_qd = cosh(arg);
+    const double Zq = tanh_qd/(1. - cos(qd*a1)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*a2)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*a3)/cosh_qd);
 
-  //convert angle degree to radian
-  theta = theta * M_PI_180;
-  phi = phi * M_PI_180;
-  psi = psi * M_PI_180;
-
-  const double Da = d_factor*dnn;
-  const double s1 = dnn/sqrt(0.75);
-
-
-  //the occupied volume of the lattice
-  const double latticescale = 2.0*sphere_volume(radius/s1);
-  // q vector
-  //q_z = 0.0; // for SANS; assuming qz is negligible
-  /// Angles here are respect to detector coordinate
-  ///  instead of against q coordinate(PRB 36(46), 3(6), 1754(3854))
-    // b3 axis orientation
-    b3_x = cos(theta) * cos(phi);
-    b3_y = sin(theta);
-    //b3_z = -cos(theta) * sin(phi);
-    cos_val_b3 =  b3_x*q_x + b3_y*q_y;// + b3_z*q_z;
-
-    //alpha = acos(cos_val_b3);
-    // b1 axis orientation
-    b1_x = -cos(phi)*sin(psi) * sin(theta)+sin(phi)*cos(psi);
-    b1_y = sin(psi)*cos(theta);
-    cos_val_b1 = b1_x*q_x + b1_y*q_y;
-    // b2 axis orientation
-    b2_x = -sin(theta)*cos(psi)*cos(phi)-sin(psi)*sin(phi);
-  	b2_y = cos(theta)*cos(psi);
-    cos_val_b2 = b2_x*q_x + b2_y*q_y;
-
-    // The following test should always pass
-    if (fabs(cos_val_b3)>1.0) {
-      //printf("bcc_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b3 = 1.0;
-    }
-    if (fabs(cos_val_b2)>1.0) {
-      //printf("bcc_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b2 = 1.0;
-    }
-    if (fabs(cos_val_b1)>1.0) {
-      //printf("bcc_ana_2D: Unexpected error: cos()>1\n");
-      cos_val_b1 = 1.0;
-    }
-    // Compute the angle btw vector q and the a3 axis
-    a3_dot_q = 0.5*dnn*q*(cos_val_b2+cos_val_b1-cos_val_b3);
-
-    // a1 axis
-    a1_dot_q = 0.5*dnn*q*(cos_val_b3+cos_val_b2-cos_val_b1);
-
-    // a2 axis
-    a2_dot_q = 0.5*dnn*q*(cos_val_b3+cos_val_b1-cos_val_b2);
-
-
-    // Get Fkq and Fkq_2
-    Fkq = exp(-0.5*pow(Da/dnn,2.0)*(a1_dot_q*a1_dot_q+a2_dot_q*a2_dot_q+a3_dot_q*a3_dot_q));
-    Fkq_2 = Fkq*Fkq;
-    // Call Zq=Z1*Z2*Z3
-    Zq = (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a1_dot_q)+Fkq_2);
-    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a2_dot_q)+Fkq_2);
-    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a3_dot_q)+Fkq_2);
-
-  // Use SphereForm directly from libigor
-  answer = sphere_form(q,radius,sld,solvent_sld)*Zq*latticescale;
-
-  return answer;
- }
+    const double Fq = sphere_form(q,radius,sld,solvent_sld)*Zq;
+    //the occupied volume of the lattice
+    const double lattice_scale = 2.0*sphere_volume(sqrt(0.75)*radius/dnn);
+    return lattice_scale * Fq;
+}
Index: sasmodels/models/bcc_paracrystal.py
===================================================================
--- sasmodels/models/bcc_paracrystal.py	(revision b0c42719ac9096c35137bf644db59e1c5915b06b)
+++ sasmodels/models/bcc_paracrystal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -128,5 +128,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/gauss150.c", "lib/sphere_form.c", "bcc_paracrystal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/gauss150.c", "lib/sphere_form.c", "bcc_paracrystal.c"]
 
 # parameters for demo
Index: sasmodels/models/be_polyelectrolyte.py
===================================================================
--- sasmodels/models/be_polyelectrolyte.py	(revision 5df888c6540361f7d5cf02845ce9d6a422974042)
+++ sasmodels/models/be_polyelectrolyte.py	(revision bf9de5336d958bc710b80a3f5618dde9593b4e94)
@@ -67,5 +67,6 @@
 * **Author:** NIST IGOR/DANSE **Date:** pre 2010
 * **Last Modified by:** Paul Kienzle **Date:** July 24, 2016
-* **Last Reviewed by:** Piotr rozyczko **Date:** January 27, 2016
+* **Last Reviewed by:** Paul Butler and Richard Heenan **Date:** 
+  October 07, 2016
 """
 
Index: sasmodels/models/binary_hard_sphere.c
===================================================================
--- sasmodels/models/binary_hard_sphere.c	(revision e481a39647a6ec1b21e8f541d254d8c65855ae34)
+++ sasmodels/models/binary_hard_sphere.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -7,10 +7,4 @@
     );
     
-double Iqxy(double qx, double qy,
-    double lg_radius, double sm_radius,
-    double lg_vol_frac, double sm_vol_frac,
-    double lg_sld, double sm_sld, double solvent_sld
-    );
-
 void calculate_psfs(double qval,
     double r2, double nf2,
@@ -55,6 +49,6 @@
     // /* do form factor calculations  */
     
-    v1 = 4.0*M_PI/3.0*r1*r1*r1;
-    v2 = 4.0*M_PI/3.0*r2*r2*r2;
+    v1 = M_4PI_3*r1*r1*r1;
+    v2 = M_4PI_3*r2*r2*r2;
     
     n1 = phi1/v1;
@@ -64,18 +58,8 @@
     qr2 = r2*q;
 
-    //if (qr1 == 0){
-        //sc1 = 1.0/3.0;
-    //}else{
-        //sc1 = (sin(qr1)-qr1*cos(qr1))/qr1/qr1/qr1;
-    //}
-    //if (qr2 == 0){
-        //sc2 = 1.0/3.0;
-    //}else{
-        //sc2 = (sin(qr2)-qr2*cos(qr2))/qr2/qr2/qr2;
-    //}
-    sc1 = sph_j1c(qr1);
-    sc2 = sph_j1c(qr2);
-    b1 = r1*r1*r1*(rho1-rhos)*4.0/3.0*M_PI*sc1;
-    b2 = r2*r2*r2*(rho2-rhos)*4.0/3.0*M_PI*sc2;
+    sc1 = sas_3j1x_x(qr1);
+    sc2 = sas_3j1x_x(qr2);
+    b1 = r1*r1*r1*(rho1-rhos)*M_4PI_3*sc1;
+    b2 = r2*r2*r2*(rho2-rhos)*M_4PI_3*sc2;
     inten = n1*b1*b1*psf11;
     inten += sqrt(n1*n2)*2.0*b1*b2*psf12;
@@ -88,17 +72,4 @@
 }
 
-
-double Iqxy(double qx, double qy,
-    double lg_radius, double sm_radius,
-    double lg_vol_frac, double sm_vol_frac,
-    double lg_sld, double sm_sld, double solvent_sld)
-    
-{
-    double q = sqrt(qx*qx + qy*qy);
-    return Iq(q,
-        lg_radius, sm_radius,
-        lg_vol_frac, sm_vol_frac,
-        lg_sld, sm_sld, solvent_sld);
-}
 
 void calculate_psfs(double qval,
Index: sasmodels/models/binary_hard_sphere.py
===================================================================
--- sasmodels/models/binary_hard_sphere.py	(revision b0c42719ac9096c35137bf644db59e1c5915b06b)
+++ sasmodels/models/binary_hard_sphere.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -108,5 +108,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "binary_hard_sphere.c"]
+source = ["lib/sas_3j1x_x.c", "binary_hard_sphere.c"]
 
 # parameters for demo and documentation
Index: sasmodels/models/capped_cylinder.c
===================================================================
--- sasmodels/models/capped_cylinder.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/capped_cylinder.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -39,5 +39,5 @@
         const double t = Gauss76Z[i]*zm + zb;
         const double radical = 1.0 - t*t;
-        const double bj = sas_J1c(qrst*sqrt(radical));
+        const double bj = sas_2J1x_x(qrst*sqrt(radical));
         const double Fq = cos(m*t + b) * radical * bj;
         total += Gauss76Wt[i] * Fq;
@@ -45,6 +45,18 @@
     // translate dx in [-1,1] to dx in [lower,upper]
     const double integral = total*zm;
-    const double cap_Fq = 2*M_PI*cube(radius_cap)*integral;
+    const double cap_Fq = 2.0*M_PI*cube(radius_cap)*integral;
     return cap_Fq;
+}
+
+static double
+_fq(double q, double h, double radius_cap, double radius, double half_length,
+    double sin_alpha, double cos_alpha)
+{
+    const double cap_Fq = _cap_kernel(q, h, radius_cap, half_length, sin_alpha, cos_alpha);
+    const double bj = sas_2J1x_x(q*radius*sin_alpha);
+    const double si = sas_sinx_x(q*half_length*cos_alpha);
+    const double cyl_Fq = 2.0*M_PI*radius*radius*half_length*bj*si;
+    const double Aq = cap_Fq + cyl_Fq;
+    return Aq;
 }
 
@@ -93,10 +105,7 @@
         SINCOS(alpha, sin_alpha, cos_alpha);
 
-        const double cap_Fq = _cap_kernel(q, h, radius_cap, half_length, sin_alpha, cos_alpha);
-        const double bj = sas_J1c(q*radius*sin_alpha);
-        const double si = sinc(q*half_length*cos_alpha);
-        const double cyl_Fq = M_PI*radius*radius*length*bj*si;
-        const double Aq = cap_Fq + cyl_Fq;
-        total += Gauss76Wt[i] * Aq * Aq * sin_alpha; // sin_alpha for spherical coord integration
+        const double Aq = _fq(q, h, radius_cap, radius, half_length, sin_alpha, cos_alpha);
+        // sin_alpha for spherical coord integration
+        total += Gauss76Wt[i] * Aq * Aq * sin_alpha;
     }
     // translate dx in [-1,1] to dx in [lower,upper]
@@ -114,21 +123,9 @@
     double theta, double phi)
 {
-    // Compute angle alpha between q and the cylinder axis
-    double sn, cn;
-    SINCOS(phi*M_PI_180, sn, cn);
-    const double q = sqrt(qx*qx+qy*qy);
-    const double cos_val = (q==0. ? 1.0 : (cn*qx + sn*qy)*sin(theta*M_PI_180)/q);
-    const double alpha = acos(cos_val); // rod angle relative to q
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
 
     const double h = sqrt(radius_cap*radius_cap - radius*radius);
-    const double half_length = 0.5*length;
-
-    double sin_alpha, cos_alpha; // slots to hold sincos function output
-    SINCOS(alpha, sin_alpha, cos_alpha);
-    const double cap_Fq = _cap_kernel(q, h, radius_cap, half_length, sin_alpha, cos_alpha);
-    const double bj = sas_J1c(q*radius*sin_alpha);
-    const double si = sinc(q*half_length*cos_alpha);
-    const double cyl_Fq = M_PI*radius*radius*length*bj*si;
-    const double Aq = cap_Fq + cyl_Fq;
+    const double Aq = _fq(q, h, radius_cap, radius, 0.5*length, sin_alpha, cos_alpha);
 
     // Multiply by contrast^2 and convert to cm-1
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/capped_cylinder.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
@@ -21,20 +21,20 @@
 .. math::
 
-    I(q) = \frac{\Delta \rho^2}{V} \left<A^2(q)\right>
+    I(q) = \frac{\Delta \rho^2}{V} \left<A^2(q,\alpha).sin(\alpha)\right>
 
-where the amplitude $A(q)$ is given as
+where the amplitude $A(q,\alpha)$ with the rod axis at angle $\alpha$ to $q$ is given as
 
 .. math::
 
     A(q) =&\ \pi r^2L
-        \frac{\sin\left(\tfrac12 qL\cos\theta\right)}
-            {\tfrac12 qL\cos\theta}
-        \frac{2 J_1(qr\sin\theta)}{qr\sin\theta} \\
+        \frac{\sin\left(\tfrac12 qL\cos\alpha\right)}
+            {\tfrac12 qL\cos\alpha}
+        \frac{2 J_1(qr\sin\alpha)}{qr\sin\alpha} \\
         &\ + 4 \pi R^3 \int_{-h/R}^1 dt
-        \cos\left[ q\cos\theta
+        \cos\left[ q\cos\alpha
             \left(Rt + h + {\tfrac12} L\right)\right]
         \times (1-t^2)
-        \frac{J_1\left[qR\sin\theta \left(1-t^2\right)^{1/2}\right]}
-             {qR\sin\theta \left(1-t^2\right)^{1/2}}
+        \frac{J_1\left[qR\sin\alpha \left(1-t^2\right)^{1/2}\right]}
+             {qR\sin\alpha \left(1-t^2\right)^{1/2}}
 
 The $\left<\ldots\right>$ brackets denote an average of the structure over
@@ -88,5 +88,6 @@
 * **Author:** NIST IGOR/DANSE **Date:** pre 2010
 * **Last Modified by:** Paul Butler **Date:** September 30, 2016
-* **Last Reviewed by:** Richard Heenan **Date:** March 19, 2016
+* **Last Reviewed by:** Richard Heenan **Date:** January 4, 2017
+
 """
 from numpy import inf
Index: sasmodels/models/core_multi_shell.c
===================================================================
--- sasmodels/models/core_multi_shell.c	(revision c5ac2b2355ae3705fd04e87490d99bfe4140d545)
+++ sasmodels/models/core_multi_shell.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -3,5 +3,5 @@
 f_constant(double q, double r, double sld)
 {
-  const double bes = sph_j1c(q * r);
+  const double bes = sas_3j1x_x(q * r);
   const double vol = M_4PI_3 * cube(r);
   return sld * vol * bes;
@@ -33,9 +33,9 @@
   f = 0.;
   for (int i=0; i<n; i++) {
-    f += M_4PI_3 * cube(r) * (sld[i] - last_sld) * sph_j1c(q*r);
+    f += M_4PI_3 * cube(r) * (sld[i] - last_sld) * sas_3j1x_x(q*r);
     last_sld = sld[i];
     r += thickness[i];
   }
-  f += M_4PI_3 * cube(r) * (solvent_sld - last_sld) * sph_j1c(q*r);
+  f += M_4PI_3 * cube(r) * (solvent_sld - last_sld) * sas_3j1x_x(q*r);
   return f * f * 1.0e-4;
 }
Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision b0c42719ac9096c35137bf644db59e1c5915b06b)
+++ sasmodels/models/core_multi_shell.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -13,5 +13,5 @@
 
 The 2D scattering intensity is the same as $P(q)$ above, regardless of the
-orientation of the $q$ vector which is defined as
+orientation of the $\vec q$ vector which is defined as
 
 .. math::
@@ -29,5 +29,5 @@
 
 Our model uses the form factor calculations implemented in a c-library provided
-by the NIST Center for Neutron Research (Kline, 2006).
+by the NIST Center for Neutron Research (Kline, 2006) [#kline]_.
 
 References
@@ -35,6 +35,7 @@
 
 .. [#] See the :ref:`core-shell-sphere` model documentation.
-.. [#] L A Feigin and D I Svergun, *Structure Analysis by Small-Angle X-Ray and Neutron Scattering*,
-   Plenum Press, New York, 1987.
+.. [#kline] S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+.. [#] L A Feigin and D I Svergun, *Structure Analysis by Small-Angle X-Ray and
+   Neutron Scattering*, Plenum Press, New York, 1987.
 
 Authorship and Verification
@@ -43,5 +44,5 @@
 * **Author:** NIST IGOR/DANSE **Date:** pre 2010
 * **Last Modified by:** Paul Kienzle **Date:** September 12, 2016
-* **Last Reviewed by:** Under Review **Date:** as of October 5, 2016
+* **Last Reviewed by:** Paul Kienzle **Date:** September 12, 2016
 """
 
@@ -100,5 +101,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "core_multi_shell.c"]
+source = ["lib/sas_3j1x_x.c", "core_multi_shell.c"]
 
 def profile(sld_core, radius, sld_solvent, n, sld, thickness):
Index: sasmodels/models/core_shell_bicelle.c
===================================================================
--- sasmodels/models/core_shell_bicelle.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/core_shell_bicelle.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
@@ -26,5 +26,5 @@
 double form_volume(double radius, double thick_rim, double thick_face, double length)
 {
-    return M_PI*(radius+thick_rim)*(radius+thick_rim)*(length+2*thick_face);
+    return M_PI*(radius+thick_rim)*(radius+thick_rim)*(length+2.0*thick_face);
 }
 
@@ -39,5 +39,6 @@
               double rhor,
               double rhosolv,
-              double dum)
+              double sin_alpha,
+              double cos_alpha)
 {
     double si1,si2,be1,be2;
@@ -49,15 +50,13 @@
     const double vol2 = M_PI*(rad+radthick)*(rad+radthick)*2.0*(length+facthick);
     const double vol3 = M_PI*rad*rad*2.0*(length+facthick);
-    double sn,cn;
-    SINCOS(dum, sn, cn);
-    double besarg1 = qq*rad*sn;
-    double besarg2 = qq*(rad+radthick)*sn;
-    double sinarg1 = qq*length*cn;
-    double sinarg2 = qq*(length+facthick)*cn;
+    double besarg1 = qq*rad*sin_alpha;
+    double besarg2 = qq*(rad+radthick)*sin_alpha;
+    double sinarg1 = qq*length*cos_alpha;
+    double sinarg2 = qq*(length+facthick)*cos_alpha;
 
-    be1 = sas_J1c(besarg1);
-    be2 = sas_J1c(besarg2);
-    si1 = sinc(sinarg1);
-    si2 = sinc(sinarg2);
+    be1 = sas_2J1x_x(besarg1);
+    be2 = sas_2J1x_x(besarg2);
+    si1 = sas_sinx_x(sinarg1);
+    si2 = sas_sinx_x(sinarg2);
 
     const double t = vol1*dr1*si1*be1 +
@@ -65,7 +64,7 @@
                      vol3*dr3*si2*be1;
 
-    const double retval = t*t*sn;
+    const double retval = t*t*sin_alpha;
 
-    return(retval);
+    return retval;
 
 }
@@ -83,12 +82,15 @@
 {
     // set up the integration end points
-    const double uplim = M_PI/4;
-    const double halfheight = length/2.0;
+    const double uplim = M_PI_4;
+    const double halfheight = 0.5*length;
 
     double summ = 0.0;
     for(int i=0;i<N_POINTS_76;i++) {
-        double zi = (Gauss76Z[i] + 1.0)*uplim;
+        double alpha = (Gauss76Z[i] + 1.0)*uplim;
+        double sin_alpha, cos_alpha; // slots to hold sincos function output
+        SINCOS(alpha, sin_alpha, cos_alpha);
         double yyy = Gauss76Wt[i] * bicelle_kernel(qq, rad, radthick, facthick,
-                             halfheight, rhoc, rhoh, rhor,rhosolv, zi);
+                             halfheight, rhoc, rhoh, rhor, rhosolv,
+                             sin_alpha, cos_alpha);
         summ += yyy;
     }
@@ -96,9 +98,9 @@
     // calculate value of integral to return
     double answer = uplim*summ;
-    return(answer);
+    return answer;
 }
 
 static double
-bicelle_kernel_2d(double q, double q_x, double q_y,
+bicelle_kernel_2d(double qx, double qy,
           double radius,
           double thick_rim,
@@ -112,20 +114,10 @@
           double phi)
 {
-    //convert angle degree to radian
-    theta *= M_PI_180;
-    phi *= M_PI_180;
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
 
-    // Cylinder orientation
-    const double cyl_x = sin(theta) * cos(phi);
-    const double cyl_y = sin(theta) * sin(phi);
-
-    // Compute the angle btw vector q and the axis of the cylinder
-    const double cos_val = cyl_x*q_x + cyl_y*q_y;
-    const double alpha = acos( cos_val );
-
-    // Get the kernel
     double answer = bicelle_kernel(q, radius, thick_rim, thick_face,
-                           length/2.0, core_sld, face_sld, rim_sld,
-                           solvent_sld, alpha) / fabs(sin(alpha));
+                           0.5*length, core_sld, face_sld, rim_sld,
+                           solvent_sld, sin_alpha, cos_alpha) / fabs(sin_alpha);
 
     answer *= 1.0e-4;
@@ -162,7 +154,5 @@
           double phi)
 {
-    double q;
-    q = sqrt(qx*qx+qy*qy);
-    double intensity = bicelle_kernel_2d(q, qx/q, qy/q,
+    double intensity = bicelle_kernel_2d(qx, qy,
                       radius,
                       thick_rim,
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision a23639a5c9b5f1b36f3c84424cf447ebd4f6285a)
+++ sasmodels/models/core_shell_bicelle.py	(revision 8afefaee3d363dde220aa55fe83181a73b621f98)
@@ -41,5 +41,5 @@
 
     I(Q,\alpha) = \frac{\text{scale}}{V_t} \cdot
-        F(Q,\alpha)^2 + \text{background}
+        F(Q,\alpha)^2.sin(\alpha) + \text{background}
 
 where
@@ -85,5 +85,5 @@
 * **Author:** NIST IGOR/DANSE **Date:** pre 2010
 * **Last Modified by:** Paul Butler **Date:** September 30, 2016
-* **Last Reviewed by:** Richard Heenan **Date:** October 5, 2016
+* **Last Reviewed by:** Richard Heenan **Date:** January 4, 2017
 """
 
@@ -141,5 +141,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/Si.c", "lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c",
+source = ["lib/sas_Si.c", "lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c",
           "core_shell_bicelle.c"]
 
@@ -156,3 +156,3 @@
             phi=0)
 
-qx, qy = 0.4 * cos(90), 0.5 * sin(0)
+#qx, qy = 0.4 * cos(pi/2.0), 0.5 * sin(0)
